import numpy as np
from math import sqrt
import matplotlib.pyplot as plt

n=1024

def fix_ham(dim,weight):
    
    s=np.zeros(dim)
    bound1=weight/2
    bound2=weight
    index=np.random.randint(0,dim,weight)
    
    for i in range(0,bound1):
        while (s[index[i]]!=0):
            index[i]=np.random.randint(0,dim,1)

        s[index[i]]=1

    for i in range(bound1,bound2):
        while (s[index[i]]!=0):
            index[i]=np.random.randint(0,dim,1)

        s[index[i]]=-1
        
    return s

def cb_dis(dim):
    e1=np.random.randint(0,2,dim)
    e2=np.random.randint(0,2,dim)
    return e1-e2


def main():

    n=1024
    s1=np.zeros(n)
    s2=np.zeros(n)

    for i in range(0,n):
        s1[i]=np.dot(fix_ham(n,n/2),fix_ham(n,n/2))
        s2[i]=np.dot(cb_dis(n),cb_dis(n))

    print "fixed hamming   dis:",s1.mean(), s1.std(), s1.max(), s1.min()
    print "center binomial dis:",s2.mean(), s2.std(), s2.max(), s2.min()

    bound=int(s1.max())+10
    dis1=np.zeros(bound*2+1)
    dis2=np.zeros(bound*2+1)

    for i in range(n):
        dis1[int(s1[i]+bound)]=dis1[int(s1[i]+bound)]+1
        dis2[int(s2[i]+bound)]=dis2[int(s2[i]+bound)]+1

    plt.plot(dis1,'.')
    plt.plot(dis2,'*')
    plt.show()

if __name__ == '__main__':
    main()




