#ifndef kex_api_h
#define kex_api_h
#include <stdint.h>

#include  "lac_param.h"

#define KEX_SECRETKEYBYTES DIM_N+PK_LEN
#define KEX_PUBLICKEYBYTES PK_LEN
#define KEX_BYTES MESSAGE_LEN
#define KEX_ALGNAME "LAC-KEMX"

//functions for ke
int kex_keygen(unsigned char *pk, unsigned char *sk);
int kex_kdf(unsigned char *pk, unsigned char *sk, unsigned char *ss);
//Alice send: generate pk and sk, and send pk to Bob
int kex_alice_send(unsigned char *pk,unsigned char *sk);
// Bob receive: receive  pk, randomly choose m, and encryrpt m with pk to generate c, k=HASH(pk,m).
int kex_bob_receive(unsigned char *pk, unsigned char *c, unsigned char *k);
//Alice receive: receive c, and decrypt to get m and comute k=HASH(pk,m)
int kex_alice_receive(unsigned char *pk, unsigned char *sk, unsigned char *c, unsigned char *k);

#endif /* kex_api_h */
